<?php
namespace OPAY\PaymentGateway\Helper;

require_once __DIR__.'/OpayGateway/opay_8.1.gateway.inc.php';

use Magento\Payment\Gateway\ConfigInterface;
use OPAY\PaymentGateway\Model\Config\Source\SignatureType;

class OpayGatewayFactory
{
    /**
     * @var ConfigInterface
     */
    protected $config;

    /**
     * Constructor
     *
     * @param ConfigInterface $config
     */
    public function __construct(ConfigInterface $config)
    {
        $this->config = $config;
    }

    /**
     * @return \OpayGateway
     */
    public function create()
    {
        $opay = new \OpayGateway();

        $signatureType = $this->config->getValue('signature_type');
        if ($signatureType == SignatureType::PASSWORD_SIGNATURE) {
            $opay->setSignaturePassword(
                $this->config->getValue('signature_password')
            );
        } elseif ($signatureType == SignatureType::RSA_SIGNATURE) {
            $opay->setMerchantRsaPrivateKey(
                $this->config->getValue('rsa_private_key')
            );
            $opay->setOpayCertificate(
                $this->config->getValue('opay_certificate')
            );
        }

        return $opay;
    }
}