<?php
namespace OPAY\PaymentGateway\Model\Config\Source;

/**
 * Used in creating options for show payment methods selection
 */
class ShowPaymentMethods implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * Show options
     */
    const IN_CHECKOUT = 'in_checkout';
    const IN_CHECKOUT_GROUPED = 'in_checkout_grouped';
    const IN_EXTERNAL_PAGE = 'in_external_page';

    /**
     * {@inheritdoc}
     *
     * @see \Magento\Framework\Data\OptionSourceInterface
     */
    public function toOptionArray()
    {
        return [
            [
                'value' => self::IN_CHECKOUT,
                'label' => __('In checkout page')
            ],
            [
                'value' => self::IN_CHECKOUT_GROUPED,
                'label' => __('In checkout page grouped')
            ],
            [
                'value' => self::IN_EXTERNAL_PAGE,
                'label' => __('In external OPAY page')
            ]
        ];
    }
}