<?php
namespace OPAY\PaymentGateway\Model\Config\Source;

/**
 * Used in creating options for signature type selection
 */
class SignatureType implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * Signature types
     */
    const PASSWORD_SIGNATURE = 'password_signature';
    const RSA_SIGNATURE = 'rsa_signature';

    /**
     * {@inheritdoc}
     *
     * @see \Magento\Framework\Data\OptionSourceInterface
     */
    public function toOptionArray()
    {
        return [
            [
                'value' => self::PASSWORD_SIGNATURE,
                'label' => __('Signature password')
            ],
            [
                'value' => self::RSA_SIGNATURE,
                'label' => __('RSA private key')
            ]
        ];
    }
}