<?php
namespace OPAY\PaymentGateway\Observer;

use Magento\Framework\Event\Observer;
use Magento\Payment\Observer\AbstractDataAssignObserver;
use Magento\Quote\Api\Data\PaymentInterface;

class DataAssignObserver extends AbstractDataAssignObserver
{
    /**
     * {@inheritdoc}
     *
     * @see \Magento\Framework\Event\ObserverInterface
     */
    public function execute(Observer $observer)
    {
        $method = $this->readMethodArgument($observer);
        $data = $this->readDataArgument($observer);

        $additionalData = $data->getDataByKey(PaymentInterface::KEY_ADDITIONAL_DATA);
        if (!is_array($additionalData)) {
            return;
        }

        $paymentInfo = $method->getInfoInstance();

        if (isset($additionalData['channel_name'])) {
            $paymentInfo->setAdditionalInformation(
                'channel_name',
                $additionalData['channel_name']
            );
        }
    }
}
